# -*- coding: utf-8 -*-
"""
Created on Mon Mar 20 11:36:48 2023

@author: embo
"""

import pandas as pd
'''
newsp_prod_T = float(input('Newsprint Production (kt) = '))
inewsp_prod_T = float(input('Improved newsprint production (kt) = '))

total_prod_T = newsp_prod_T + inewsp_prod_T
'''
##### FLOWS #####
parameters_df = pd.read_excel('Parameters.xlsx',sheet_name='parameters')

for i_param in range(len(parameters_df.index)):
    locals()[parameters_df.iloc[i_param,1]] = parameters_df.iloc[i_param,3]

relationship_df = pd.read_excel('Parameters.xlsx', sheet_name='relationship').fillna(value=0)

for flow in relationship_df.iloc[:,0]:
    if type(flow)==str:
        locals()[flow] = None

flows_df = pd.read_excel('Parameters.xlsx', sheet_name='flows').fillna(value=0)


A08t = 0 # Return paper (t) (initial value 77606)
NP = 406278 #Newsprint (t) (initial value 406278)
INP = 95148 #Improved newsprint (t) (initial value 95148)
PC = 60831 #Purchased chips (t) (initial value 60831)

results = pd.DataFrame(columns=['t','td','tf','ca','tp'])

for row in range(len(relationship_df.index)):
    #print(row)
    if type(relationship_df.iloc[row,0])==str:
        last_i = relationship_df.iloc[row,:].to_list().index(0)
        equation = relationship_df.iloc[row,:last_i]
        locals()[equation.iloc[0]] = eval(equation[2:].sum())
        #print(relationship_df.iloc[row,0])
        #print(equation.sum())
        
        if relationship_df.iloc[row,0][3] == 't':
            i = relationship_df.iloc[row,0][:3]
        else:
            i = relationship_df.iloc[row,0][:4]
            
        results.loc[i,relationship_df.iloc[row,0][-2:]] = locals()[equation.iloc[0]]
        
#%% ##### ENERGY #####

e_relationship_df = pd.read_excel('Parameters.xlsx', sheet_name='e_relationship').fillna(value=0)

for flow in e_relationship_df.iloc[:,0]:
    if type(flow)==str:
        locals()[flow] = None

e_results = pd.DataFrame(columns=['MWh'])

for row in range(len(e_relationship_df.index)):
    #print(row)
    if type(e_relationship_df.iloc[row,0])==str:
        last_i = e_relationship_df.iloc[row,:].to_list().index(0)
        equation = e_relationship_df.iloc[row,:last_i]
        locals()[equation.iloc[0]] = eval(equation[2:].sum())
        #print(relationship_df.iloc[row,0])
        #print(equation.sum())              
        e_results.loc[e_relationship_df.iloc[row,0],'MWh'] = locals()[equation.iloc[0]]

#%% Without having to increase prod of steam to dry bark

dc_bark_i = 0.5 # Bark initial dry content
dc_bark_f = 0.8 # Bark final dry content

water_to_dry = A56td*(1/dc_bark_i - 1/dc_bark_f) # amount of water to dry

e_to_dry_kjgh2o = 3.997321429 #kj/gH2O   0C-80% -> 47C-80%-2 stages
e_to_dry_mwhth2o = e_to_dry_kjgh2o/3.6 #MWh/tH2O

e_to_dry = water_to_dry*e_to_dry_mwhth2o #MWh
surplus_low_T_heat = 115000 #MWh

if e_to_dry>surplus_low_T_heat:
    add_energy_dry = e_to_dry-surplus_low_T_heat
else:
    add_energy_dry = 0

total_steam_need = EPM+ETMP+ERP+EDEBARK+EVVF+SSBOILER+add_energy_dry # demand of steam
Prod_eboil = total_steam_need * PSEBOILER # production of electric boiler
Prod_boil = (total_steam_need - Prod_eboil - SPTMP)*1/(1-SHBOILER) # production of boiler MWh
e_input_boiler = Prod_boil/KBOILER # energy of the fuel required

e_bark = (a_bark*(1-dc_bark_f)+b_bark)*A56td/dc_bark_f/3.6 #energy from bark
e_DIP = QDIP*A86atd
e_bioslam = QFIBERSLAM*A96td
e_RF = QRFREJECTS*A86btd


from scipy.optimize import fsolve,least_squares
import numpy as np

def mass_oil_biobrensel(x): #x[0] e_oil, x[1] m_biobrensel
    MC_fuel = 1-((DCBIOBR)*x[1]+A86atd+A86btd+A96td+A56td)/(x[1]+A86atd/DCDIP+A86btd/DCRFR+A96td/DCBIOS+A56td/dc_bark_f)
    return [-x[0] + a_oil*MC_fuel + b_oil ,
            -e_input_boiler + x[0] + Eoil_min + e_bark + x[1]*DCBIOBR*QBIOBRENSEL + e_DIP + e_RF + e_bioslam]

e_oil,m_biobrensel = fsolve(mass_oil_biobrensel,[0,0])

if e_oil<0:
    def mass_oil_biobrensel(x): # x = m_biobrensel
        return -e_input_boiler + 0 + Eoil_min + e_bark + x*DCBIOBR*QBIOBRENSEL + e_DIP + e_RF + e_bioslam
    
    e_oil,m_biobrensel = 0,fsolve(mass_oil_biobrensel,0)[0]
    

m_oil = (e_oil+Eoil_min)/QOIL
#nik = least_squares(mass_oil_biobrensel,[0.1,0.1],bounds=([0,0],[np.inf,np.inf]),method='dogbox')


results.loc['oil','oil'] = m_oil
results.loc['biobrensel',['t','td','tf','tp']]=[m_biobrensel,m_biobrensel*DCBIOBR,m_biobrensel*DCBIOBR*(1-0.01/100),m_biobrensel*DCBIOBR*0.01/100]
results = results.fillna(0)

results.loc['A60','td':] = results.loc[['A86a','A86b','A96','A56','oil','biobrensel']].sum(axis=0)
results.loc['A86',:] =results.loc[['A86a','A86b'],:].sum(axis=0)
results = results.fillna(0)

#%% ##### Carbon results #####

CinCO2 =12/(12+2*16)
CinCaCO3 = 0.12
CinFib = 0.5
CO2inPlast = 2.71
CO2inoil = 0.0431*73.5

#tf,tca,tpl,toil
c_coeff = [CinFib,CinCaCO3,CO2inPlast*CinCO2,CO2inoil*CinCO2]

c_results = np.einsum('ij,j->ij',results.loc[:,['tf','ca','tp','oil']].fillna(0).to_numpy(),np.array(c_coeff))

c_results = pd.DataFrame(c_results,index= results.index,columns=['Fib','CaCO3','Plast','Oil'])

c_results.loc[:,'sum'] = c_results.sum(axis=1)

#%% ##### Export results #####

results.to_excel('S3_results.xlsx')
c_results.to_excel('S3_c_results.xlsx')